SystemOrganization addCategory: #ConfigurationOfSMustache!

Object subclass: #ConfigurationOfSMustache
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSMustache'!

!ConfigurationOfSMustache class methodsFor: 'development support' stamp: 'JesusMari 4/6/2013 19:22'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSMustache class methodsFor: 'private' stamp: 'JesusMari 4/6/2013 19:22'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSMustache class methodsFor: 'private' stamp: 'JesusMari 4/6/2013 19:22'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSMustache class methodsFor: 'private' stamp: 'JesusMari 4/6/2013 19:22'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSMustache class methodsFor: 'metacello tool support' stamp: 'JesusMari 4/6/2013 19:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSMustache class methodsFor: 'loading' stamp: 'JesusMari 4/6/2013 19:22'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSMustache class methodsFor: 'loading' stamp: 'JesusMari 4/6/2013 19:22'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSMustache class methodsFor: 'loading' stamp: 'JesusMari 4/6/2013 19:22'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSMustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/6/2013 19:44'!
migrateToSMustache: aVersion
| gofer |
"Identify the source repository"
gofer := Gofer new url: 'http://ss3.gemstone.com/ss/SCouchViewServer';
package: 'ConfigurationOfSMustache' yourself.
"Traverse all packages defined in baseline '1.7-baseline' of the Fuel configuration"
(ConfigurationOfSMustache project version:aVersion) packages do:[:spec |
"Use the #name and #package: messages and Gofer will fetch
all versions of the Monticello package"
gofer package: spec name ].
"Initiate the download with the #fetch command"
gofer fetch.

"Identify the target repository"
gofer := Gofer new url: 'http://ss3.gemstone.com/ss/SMustache'
	username: 'jmari'
	password: '95t5boru';
package: 'ConfigurationOfSMustache' yourself.
"Use the same algorithm for identifying the packages to be pushed"
(ConfigurationOfSMustache project version: aVersion) packages do:[:spec |
gofer package: spec name ].
"Initiate the upload with the #push command"
gofer push.! !

!ConfigurationOfSMustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/6/2013 19:22'!
migrateToSmalltalkHub: aVersion
| gofer |
"Identify the source repository"
gofer := Gofer new url: 'http://ss3.gemstone.com/ss/SCouchViewServer';
package: 'ConfigurationOfSCouchDB' yourself.
"Traverse all packages defined in baseline '1.7-baseline' of the Fuel configuration"
(ConfigurationOfSCouchDB project version:aVersion) packages do:[:spec |
"Use the #name and #package: messages and Gofer will fetch
all versions of the Monticello package"
gofer package: spec name ].
"Initiate the download with the #fetch command"
gofer fetch.

"Identify the target repository"
gofer := Gofer new url: 'http://smalltalkhub.com/mc/jmari/SCouchDBViewServer/main/'
	username: 'jmari'
	password: '*******';
package: 'ConfigurationOfSCouchDB' yourself.
"Use the same algorithm for identifying the packages to be pushed"
(ConfigurationOfSCouchDB project version: aVersion) packages do:[:spec |
gofer package: spec name ].
"Initiate the upload with the #push command"
gofer push.! !

!ConfigurationOfSMustache class methodsFor: 'accessing' stamp: 'JesusMari 4/6/2013 19:22'!
project

	^self new project! !

!ConfigurationOfSMustache class methodsFor: 'development support' stamp: 'JesusMari 4/6/2013 19:22'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSMustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/6/2013 19:59'!
baseline11: spec
	<version: '1.1-baseline'>

	spec for: #common do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/SMustache'.
		spec project: 'SeasideCore' with: [
   			spec
     				className: 'ConfigurationOfSeaside30';
     				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec project:'SeasideMobile' with:[
			spec
				className: 'ConfigurationOfJQueryMobile';
     				versionString: #bleedingEdge;
     				repository: 'http://ss3.gemstone.com/ss/jQueryMobile' 
			].
		spec 
			package: 'Mustache-Core' with:[spec requires:#('JSON')];
			package: 'Mustache-Tests' with:[spec requires:#('Mustache-Core' )];
			package: 'Mustache-Seaside-Core' with:[spec requires:#('Mustache-Core' 'SeasideCore')];
			package: 'Mustache-Seaside-Tests' with:[spec requires:#('Mustache-Seaside-Core')];
			package: 'Mustache-Seaside-Libs'with:[spec requires:'SeasideCore'];
			package: 'Mustache-Seaside-Examples' with:[spec requires: #('Mustache-Seaside-Tests')].
			
			
		spec 
			group: 'base' with:#('JSON');
			group: 'default' with: #('base' 'Mustache-Core' 'Mustache-Tests' 'Mustache-Seaside-Core' 'Mustache-Seaside-Tests' 'Mustache-Seaside-Libs');
			group: 'mustache' with:#('JSON' 'Mustache-Core' 'Mustache-Tests');
			group: 'mustache-seaside' with:#('mustache'  'Mustache-Seaside-Core' 'Mustache-Seaside-Tests' 'Mustache-Seaside-Libs');
			group: 'examples' with:#('mustache-seaside' 'Mustache-Seaside-Examples') 
		 ].
	
spec for: #squeak do: [
	spec project: 'regExp' with: [
   			spec
				loads:'VB-Regex';
     				repository: 'http://source.squeak.org/inbox'
				username:'squeak'
				password:'squeak' ].
	spec
			package: 'JSON-Platform' with: 'JSON-Squeak'. "only Squeak"
	spec group: 'base' with:#('JSON' 'JSON-Platform')
] ! !

!ConfigurationOfSMustache methodsFor: 'symbolic versions' stamp: 'JesusMari 4/6/2013 19:22'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfSMustache methodsFor: 'accessing' stamp: 'JesusMari 4/6/2013 19:22'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSMustache methodsFor: 'symbolic versions' stamp: 'JesusMari 4/6/2013 19:22'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfSMustache methodsFor: 'versions' stamp: 'JesusMari 4/6/2013 19:33'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '
-version 1.2
better categories organizacion and tests
- categories reorganization and tests'.
		spec author: 'JesusMari'.
		spec timestamp: '4/2/2013 12:42'.
		spec 
			package: 'JSON' with: 'JSON-JesusMari.Stasenko.48';
			package: 'Mustache-Core' with: 'Mustache-Core-JesusMari.23';
			package: 'Mustache-Seaside-Core' with: 'Mustache-Seaside-Core-JesusMari.5';
			package: 'Mustache-Seaside-Tests' with: 'Mustache-Seaside-Tests-JesusMari.1';
			package: 'Mustache-Seaside-Libs' with: 'Mustache-Seaside-Libs-JesusMari.3';
			package: 'Mustache-Tests' with: 'Mustache-Tests-JesusMari.6';
			package: 'Mustache-Seaside-Examples' with: 'Mustache-Seaside-Examples-JesusMari.3'.

	spec for: #'squeak' do: [
		spec 
			package: 'JSON-Platform' with: 'JSON-Squeak-jma.1']
		].
! !
